<template>
  <div id="admin">
    <CoscineHeadline :headline="$t('page.admin.headline')" />

    <!-- Project String Input Field -->
    <b-form @submit.stop.prevent="queryProject()">
      <b-input-group class="mt-3">
        <b-form-input
          v-model="projectString"
          :placeholder="$t('page.admin.projectInputPlaceholder')"
          class="shadow-none"
        />

        <!-- Select Button -->
        <template #append>
          <b-button variant="primary" @click="queryProject()">
            {{ $t("buttons.submit") }}
          </b-button>
        </template>
      </b-input-group>
    </b-form>

    <!-- Project Query Status -->
    <span class="d-block h6 my-3">
      {{
        project && project.id
          ? $t("page.admin.projectFound")
          : $t("page.admin.projectNotSelected")
      }}
    </span>

    <!-- Project Name -->
    <CoscineFormGroup
      :label="$t('page.admin.form.projectNameLabel')"
      label-cols-sm="2"
      label-align-sm="left"
    >
      <b-form-input
        :model-value="project ? project.name : ''"
        readonly
        :disabled="true"
      />
    </CoscineFormGroup>

    <!-- Project Display Name -->
    <CoscineFormGroup
      :label="$t('page.admin.form.displayNameLabel')"
      label-cols-sm="2"
      label-align-sm="left"
    >
      <b-form-input
        :model-value="project ? project.displayName : ''"
        readonly
        :disabled="true"
      />
    </CoscineFormGroup>

    <!-- Project Guid -->
    <CoscineFormGroup
      :label="$t('page.admin.form.projectIdLabel')"
      label-cols-sm="2"
      label-align-sm="left"
    >
      <b-form-input
        :model-value="project ? project.id : ''"
        readonly
        :disabled="true"
      />
    </CoscineFormGroup>

    <div class="h-divider" />

    <!-- Quota Table -->
    <QuotaTable />
  </div>
</template>

<script lang="ts">
// import the store for current module
import useAdminStore from "../store";

import QuotaTable from "../components/QuotaTable.vue";
import type { ProjectDto } from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  components: {
    QuotaTable,
  },

  setup() {
    const adminStore = useAdminStore();

    return { adminStore };
  },

  data() {
    return {
      projectString: "",
    };
  },

  computed: {
    project(): ProjectDto | null | undefined {
      return this.adminStore.project;
    },
  },

  methods: {
    async queryProject() {
      if (!this.projectString.trim()) {
        this.adminStore.project = null;
      } else {
        await this.adminStore.retrieveProjectAndQuotas(this.projectString);
      }
    },
  },
});
</script>
